#pragma once

#include <gst/gstmessage.h>
#include <gst/gstutils.h>
#include <string>

#include "viflow/error.hxx"
#include "viflow/shared_element.hxx"
#include "viflow/unique_resources.hxx"

namespace viflow {

/**
 * @brief Converts a GstMessageType to a string.
 *
 * @param type The GstMessageType to convert.
 *
 * @return std::string The string representation of the GstMessageType.
 */
inline std::string to_string(GstMessageType type) {
  return gst_message_type_get_name(type);
}

/**
 * @brief Converts a GstState to a string.
 *
 * @param type The GstState to convert.
 *
 * @return std::string The string representation of the GstState.
 */
inline std::string to_string(GstState type) {
  return gst_element_state_get_name(type);
}

/**
 * @brief Unreferences a GstMessage.
 *
 * @param msg The GstMessage to unreference.
 */
inline void gst_message_unref(GstMessage *msg) {
  gst_mini_object_unref(GST_MINI_OBJECT_CAST(msg));
}

/**
 * @brief Useful when dealing with low level GstMessage instances.
 */
using unique_message = unique_ptr_fn<GstMessage, viflow::gst_message_unref>;

/**
 * @brief Adapter for GstMessage.
 */
class Message {
public:
  /**
   * @brief The context of a GST_MESSAGE_STATE_CHANGED message.
   */
  struct State_Change {
    GstState old_state{GST_STATE_VOID_PENDING};
    GstState new_state{GST_STATE_VOID_PENDING};
    GstState pending_state{GST_STATE_VOID_PENDING};
  };

  /**
   * @brief The context of a GST_MESSAGE_INFO, GST_MESSAGE_WARNING or
   * GST_MESSAGE_ERROR message.
   */
  struct Context {
    Error error;
    unique_g_str debug;
  };

  /**
   * @brief Extracts the message from a structure.
   *
   * @param s The GstStructure to extract the message from.
   *
   * @return Message The extracted message.
   *
   * @throw Exception If the message cannot be extracted.
   */
  static Message from_struct(const GstStructure *s);

  /**
   * @brief Increases the reference count and takes ownership of a GstMessage.
   *
   * @param m The GstMessage to reference.
   *
   * @return Message The referenced message.
   *
   * @throw Exception If the message cannot be referenced.
   */
  static Message ref(GstMessage *m);

  /**
   * @brief Increases the reference count and takes ownership of a Message.
   *
   * @param m The Message to reference.
   *
   * @return Message The referenced message.
   *
   * @throw Exception If the message cannot be referenced.
   */
  static Message ref(const Message &m);

  Message(const Message &m) = delete;
  Message(Message &&m) = default;
  virtual ~Message() {}
  Message &operator=(const Message &m) = delete;
  Message &operator=(Message &&m) = default;
  /**
   * @brief Take ownership of the message.
   *
   * @param message The GstMessage instance.
   */
  explicit Message(GstMessage *message);

  /**
   * @brief Checks whether the low level message is null.
   *
   * @return bool True if the message is null, false otherwise.
   */
  bool empty();

  /**
   * @brief Returns the message type.
   *
   * @return GstMessageType The type of the message.
   */
  GstMessageType get_type() const noexcept { return core->type; }

  /**
   * @brief Returns the message type name.
   *
   * @return std::string The name of the message type.
   */
  std::string get_type_name() const noexcept;

  /**
   * @brief Asserts that the message has a specific type.
   *
   * @param expected The expected type.
   *
   * @throw Wrong_Message_Type If the message type is not the expected one.
   */
  void assert_type(GstMessageType expected) const;

  /**
   * @brief Returns the element that produced the message.
   *
   * @return std::string The name of the element that produced the message.
   */
  std::string get_source_name() const;

  /**
   * @brief Returns the element's source.
   *
   * This returns the raw element because messages are often generated by
   * unregistered elements (elements created automatically by GStreamer).
   *
   * @return Shared_Element<> The source element of the message.
   */
  Shared_Element<> get_source() const;

  /**
   * @brief Returns the context for this particular type or message.
   *
   * @return Context The context of the message.
   *
   * @throw Wrong_Message_Type If the message type is not GST_MESSAGE_INFO.
   */
  Context parse_info() const;

  /**
   * @brief Returns the context for this particular type or message.
   *
   * @return Context The context of the message.
   *
   * @throw Wrong_Message_Type If the message type is not GST_MESSAGE_WARNING.
   */
  Context parse_warning() const;

  /**
   * @brief Returns the context for this particular type or message.
   *
   * @return Context The context of the message.
   *
   * @throw Wrong_Message_Type If the message type is not GST_MESSAGE_ERROR.
   */
  Context parse_error() const;

  /**
   * @brief Returns the context for this particular type or message.
   *
   * @return State_Changed_Context The context of the message.
   *
   * @throw Wrong_Message_Type If the message type is not
   * GST_MESSAGE_STATE_CHANGED.
   */
  State_Change parse_state_changed() const;

  /**
   * @brief Returns the buffering percent.
   *
   * @return int The buffering percent.
   *
   * @throw Wrong_Message_Type If the message type is not GST_MESSAGE_BUFFERING.
   */
  int parse_buffering() const;

  /**
   * @brief Checks if the message has a specific name.
   *
   * @param name The name to check.
   *
   * @return bool True if the message has the specified name, false otherwise.
   */
  bool has_name(const std::string &name) const;

  /**
   * @brief Returns the message structure.
   *
   * @return const GstStructure* The structure of the message.
   */
  const GstStructure *get_structure() const;

  /**
   * @brief Returns the low level message.
   *
   * @return GstMessage* The low level message.
   */
  GstMessage *get_core() const noexcept { return core.get(); }

  /**
   * @brief Releases the ownership of the message and returns it.
   *
   * @return GstMessage* The released message.
   */
  GstMessage *release() noexcept { return core.release(); }

private:
  /**
   * @brief Low level representation of the message.
   */
  unique_message core;
};

} // namespace viflow
